/* GCC */
#include <iostream>

#define INF 1000000000

using namespace std;

struct type_nest
{
       int parent, left, right, x, y;
};

long long ans = 0;
int n, root = 0;
type_nest nest[250010];

void dist( int v )
{
     if( nest[v].left != INF )
     {
         ans += ( long long ) abs( ( long long ) nest[v].x - nest[nest[v].left].x ) + ( long long ) abs( ( long long ) nest[v].y - nest[nest[v].left].y );
         dist( nest[v].left );
     }
     if( nest[v].right != INF )
     {
         ans += ( long long ) abs( ( long long ) nest[v].x - nest[nest[v].right].x ) + ( long long ) abs( ( long long ) nest[v].y - nest[nest[v].right].y );
         dist( nest[v].right );
     }
     return;
}

int main()
{
    freopen("nests.in", "r", stdin);
    freopen("nests.out", "w", stdout);
    scanf("%d%d%d", &n, &nest[0].x, &nest[0].y);
    nest[0].left = INF;
    nest[0].right = INF;
    for( int i = 1; i < n; i++ )
    {
         scanf("%d%d", &nest[i].x, &nest[i].y);
         nest[i].left = INF;
         nest[i].right = INF;
         
         if( nest[root].y < nest[i].y ) 
         {
             nest[i].left = root;
             nest[root].parent = i;
             root = i;
             continue;
         }
         int k = i - 1;
         while( nest[k].y < nest[i].y ) k = nest[k].parent;
         nest[i].left = nest[k].right;
         nest[i].parent = k;
         nest[k].right = i;
    }
    dist( root );
    cout << ans << endl;
    fclose(stdin);
    fclose(stdout);
    return 0;
}
