/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

int PrimePermut[8][4] =
{
{0,0,0,0},
{0,0,0,1},
{0,0,1,1},
{0,0,1,2},
{0,1,1,1},
{0,1,1,2},
{0,1,2,2},
{0,1,2,3}
};

int Len[8] = {1,4,6,12,4,12,12,12};

int PrimePermutGo[8][12][4] =
{
{
{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}
},
{
{0,0,0,1},{0,0,1,0},{0,1,0,0},{1,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}
},
{
{0,0,1,1},{0,1,0,1},{0,1,1,0},{1,0,0,1},{1,0,1,0},{1,1,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}
},
{
{0,0,1,2},{0,0,2,1},{0,1,0,2},{0,1,2,0},{0,2,0,1},{0,2,1,0},{1,0,0,2},{1,0,2,0},{1,2,0,0},{2,0,0,1},{2,0,1,0},{2,1,0,0}
},
{
{0,1,1,1},{1,0,1,1},{1,1,0,1},{1,1,1,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}
},
{
{0,1,1,2},{0,1,2,1},{0,2,1,1},{1,0,1,2},{1,0,2,1},{1,1,0,2},{1,1,2,0},{1,2,0,1},{1,2,1,0},{2,0,1,1},{2,1,0,1},{2,1,1,0}
},
{
{0,1,2,2},{0,2,1,2},{0,2,2,1},{1,0,2,2},{1,2,0,2},{1,2,2,0},{2,0,1,2},{2,0,2,1},{2,1,0,2},{2,1,2,0},{2,2,0,1},{2,2,1,0}
},
{
{0,1,2,3},{0,2,3,1},{0,3,1,2},{1,0,3,2},{1,2,0,3},{1,3,2,0},{2,0,1,3},{2,1,3,0},{2,3,0,1},{3,0,2,1},{3,1,0,2},{3,2,1,0}
}
};

int Move[8][12][4] =
{
{
{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},
},
{
{4,4,4,4},{3,4,4,4},{3,3,4,4},{2,3,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},
},
{
{4,4,4,4},{3,3,4,4},{3,4,4,4},{2,2,4,4},{2,4,4,4},{2,3,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},
},
{
{4,4,4,4},{1,2,4,4},{2,2,3,4},{3,4,4,4},{3,3,4,4},{2,3,3,4},{1,2,3,4},{2,4,4,4},{2,2,3,3},{2,2,4,4},{1,2,3,3},{2,3,4,4},
},
{
{4,4,4,4},{1,2,4,4},{2,2,4,4},{2,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},{4,4,4,4},
},
{
{4,4,4,4},{3,4,4,4},{3,3,4,4},{1,2,3,4},{1,2,4,4},{2,2,3,4},{2,4,4,4},{2,2,3,3},{2,3,3,4},{1,2,3,3},{2,2,4,4},{2,3,4,4},
},
{
{4,4,4,4},{3,3,4,4},{3,4,4,4},{1,2,4,4},{2,2,3,4},{2,3,3,4},{1,2,3,4},{1,2,3,3},{2,2,4,4},{2,4,4,4},{2,2,3,3},{2,3,4,4},
},
{
{4,4,4,4},{3,4,4,4},{3,3,4,4},{1,2,4,4},{2,2,3,4},{2,3,3,4},{1,2,3,4},{2,4,4,4},{2,2,3,3},{1,2,3,3},{2,2,4,4},{2,3,4,4},
}
};

// 0 = (0 , 1 , 2)
// 1 = (0 , 1 , 3)
// 2 = (0 , 2 , 3)
// 3 = (1 , 2 , 3);

int t , N , M[222][222] , A[111][111] , Used[111 * 111][111] , P[4] , Q[4] , Answer[1110 * 111] , AnswerSize;
int T[4] , K[4] , V[4] , PrimePermutID , SubPermutID , Save[222][222];

void Sort(int x , int y)
{

    T[0] = M[0][0];
    T[1] = M[2 * N - 1][0];
    T[2] = M[0][2 * N - 1];
    T[3] = M[2 * N - 1][2 * N - 1];
    for (int i = 0 ; i < 4 ; i ++ )
        V[i] = T[i];
    sort(T , T + 4);
    for (int i = 0 ; i < 4 ; i ++ )
        K[i] = T[i];
    int cnt = 0;
    int it = 1;
    for (int i = 0 ; i < 4 ; i ++ )
    {
      while ( it < 4 && T[it] == T[i] )
            it ++ ;
      for (int j = i ; j < it ; j ++ )
        T[j] = cnt;
      cnt ++ ;
      i = it - 1;
    };

    for (int i = 0 ; i < 4 ; i ++ )
        for (int j = 0 ; j < 4 ; j ++ )
            if ( V[i] == K[j] )
            {
                V[i] = T[j];
                break;
            };

    for (int i = 0 ; i < 8 ; i ++ )
        if ( T[0] == PrimePermut[i][0] && T[1] == PrimePermut[i][1] &&
             T[2] == PrimePermut[i][2] && T[3] == PrimePermut[i][3] )
        {
            PrimePermutID = i;
            break;
        };

    SubPermutID = -1;

    for (int j = 0 ; j < Len[PrimePermutID] ; j ++ )
        if ( V[0] == PrimePermutGo[PrimePermutID][j][0] && V[1] == PrimePermutGo[PrimePermutID][j][1] &&
             V[2] == PrimePermutGo[PrimePermutID][j][2] && V[3] == PrimePermutGo[PrimePermutID][j][3] )
        {
            SubPermutID = j;
            break;
        };

    if ( SubPermutID == -1 )
    {
        Answer[AnswerSize ++ ] = x + 1;
        swap(V[0] , V[2]);
        for (int i = 0 ; i < N ; i ++ )
            swap(M[0][i] , M[0][2 * N - i - 1]);
        for (int j = 0 ; j < Len[PrimePermutID] ; j ++ )
        if ( V[0] == PrimePermutGo[PrimePermutID][j][0] && V[1] == PrimePermutGo[PrimePermutID][j][1] &&
             V[2] == PrimePermutGo[PrimePermutID][j][2] && V[3] == PrimePermutGo[PrimePermutID][j][3] )
        {
            SubPermutID = j;
            break;
        };
    };

    for (int i = 0 ; i < 4 ; i ++ )
    {
      if ( Move[PrimePermutID][SubPermutID][i] == 0 )
      {
        Answer[AnswerSize ++ ] = (x + 1);
        Answer[AnswerSize ++ ] = -y - 1;
        Answer[AnswerSize ++ ] = x + 1;
        Answer[AnswerSize ++ ] = -y - 1;
      };
      if ( Move[PrimePermutID][SubPermutID][i] == 1 )
      {
        Answer[AnswerSize ++ ] = -y - 1;
        Answer[AnswerSize ++ ] = 2 * N - x;
        Answer[AnswerSize ++ ] = -y - 1;
        Answer[AnswerSize ++ ] = 2 * N - x;
      };
      if ( Move[PrimePermutID][SubPermutID][i] == 2 )
      {
        Answer[AnswerSize ++ ] = x + 1;
        Answer[AnswerSize ++ ] = -(2 * N - y);
        Answer[AnswerSize ++ ] = x + 1;
        Answer[AnswerSize ++ ] = -(2 * N - y);
      };
      if ( Move[PrimePermutID][SubPermutID][i] == 3 )
      {
        Answer[AnswerSize ++ ] = -(2 * N - y);
        Answer[AnswerSize ++ ] = 2 * N - x;
        Answer[AnswerSize ++ ] = -(2 * N - y);
        Answer[AnswerSize ++ ] = 2 * N - x;
      };
    };
    M[0][0] = K[0];
    M[2 * N - 1][0] = K[1];
    M[0][2 * N  - 1] = K[2];
    M[2 * N - 1][2 * N - 1] = K[3];
};


int main()
{
    freopen("square.in","r",stdin);
    freopen("square.out","w",stdout);
    scanf("%d",&t);
    for (int q = 1 ; q <= t ; q ++ )
    {
        AnswerSize = 0;
        scanf("%d",&N);
            for (int i = 0 ; i < 2 * N ; i ++ )
                for (int j = 0 ; j < 2 * N ; j ++ )
                    scanf("%d",&M[i][j]) , Save[i][j] = M[i][j];


            for (int i = 0 ; i < N ; i ++ )
                for (int j = 0 ; j < N ; j ++ )
                    for (int k = 1 ; k <= 100 ; k ++ )
                        Used[i * N + j][k] = 0;



            for (int i = 0 ; i < N ; i ++ )
                for (int j = 0 ; j < N ; j ++ )
                {
                    Used[i * N + j][M[i][j]] ++ ;
                    Used[i * N + j][M[2 * N - i - 1][j]] ++ ;
                    Used[i * N + j][M[i][2 * N - j - 1]] ++ ;
                    Used[i * N + j][M[2 * N - i - 1][2 * N - j - 1]] ++ ;
                };


            bool NotSame = false;
            for (int i = 0 ; i < N && !NotSame ; i ++ )
                for (int j = 0 ; j < N && !NotSame ; j ++ )
                    for (int k = 1 ; k <= 100 && !NotSame ; k ++ )
                        if ( Used[i * N + j][k] != Used[0][k] )
                            NotSame = true;
            if ( NotSame )
            {
              printf("-1\n");
              continue;
            };

            Sort(0 , 0);

            for (int i = 0 ; i < 2 * N ; i ++ )
                for (int j = 0 ; j < 2 * N ; j ++ )
                    for (int k = 0 ; k < 4 ; k ++ )
                        if ( M[i][j] == K[k] )
                        {
                            M[i][j] = T[k];
                            break;
                        };



            for (int i = 0 ; i < N ; i ++ )
                for (int j = 0 ; j < N ; j ++ )
                {
                    bool found_permut = false;
                    for (int k = 0 ; k < Len[PrimePermutID] ; k ++ )
                        if ( M[i][j] == PrimePermutGo[PrimePermutID][k][0] &&
                             M[2 * N - 1 - i][j] == PrimePermutGo[PrimePermutID][k][1] &&
                             M[i][2 * N - 1 - j] == PrimePermutGo[PrimePermutID][k][2] &&
                             M[2 * N - 1 - i][2 * N - 1 - j] == PrimePermutGo[PrimePermutID][k][3] )
                    {
                        found_permut = true;
                        break;
                    }
                    A[i][j] = found_permut;
                };



        for (int i = 1 ; i < N ; i ++ )
            if ( !A[i][0] )
            {
                Answer[AnswerSize ++ ] = i + 1;
                for (int j = 0 ; j < N ; j ++ )
                {
                  swap(M[i][j] , M[i][2 * N - j - 1]);
                  A[i][j] ^= 1;
                };
            };

        for (int i = 1 ; i < N ; i ++ )
            if ( !A[0][i] )
            {
                Answer[AnswerSize ++ ] = -i - 1;
                for (int j = 0 ; j < N ; j ++ )
                {
                  swap(M[j][i] , M[2 * N - j - 1][i]);
                  A[j][i] ^= 1;
                };
            };

        bool FoundZero = false;
        for (int i = 0 ; !FoundZero && i < N ; i ++ )
            for (int j = 0 ; !FoundZero && j < N ; j ++ )
            if ( !A[i][j] )
            FoundZero = true;

        if ( FoundZero )
        {
          printf("-1\n");
          continue;
        };

        for (int i = 0 ; i < N ; i ++ )
            for (int j = 0 ; j < N ; j ++ )
            {
                int SubPermutID = -1;
                for (int k = 0 ; k < Len[PrimePermutID] ; k ++ )
                        if ( M[i][j] == PrimePermutGo[PrimePermutID][k][0] &&
                             M[2 * N - 1 - i][j] == PrimePermutGo[PrimePermutID][k][1] &&
                             M[i][2 * N - 1 - j] == PrimePermutGo[PrimePermutID][k][2] &&
                             M[2 * N - 1 - i][2 * N - 1 - j] == PrimePermutGo[PrimePermutID][k][3] )
                    {
                        SubPermutID = k;
                        break;
                    };

                for (int k = 0 ; k < 4 ; k ++ )
                {
                    if ( Move[PrimePermutID][SubPermutID][k] == 0 )
                      {
                        Answer[AnswerSize ++ ] = i + 1;
                        Answer[AnswerSize ++ ] = -j - 1;
                        Answer[AnswerSize ++ ] = i + 1;
                        Answer[AnswerSize ++ ] = -j - 1;
                      };
                      if ( Move[PrimePermutID][SubPermutID][k] == 1 )
                      {
                        Answer[AnswerSize ++ ] = -j - 1;
                        Answer[AnswerSize ++ ] = 2 * N - i;
                        Answer[AnswerSize ++ ] = -j - 1;
                        Answer[AnswerSize ++ ] = 2 * N - i;
                      };
                      if ( Move[PrimePermutID][SubPermutID][k] == 2 )
                      {
                        Answer[AnswerSize ++ ] = i + 1;
                        Answer[AnswerSize ++ ] = -(2 * N - j);
                        Answer[AnswerSize ++ ] = i + 1;
                        Answer[AnswerSize ++ ] = -(2 * N - j);
                      };
                      if ( Move[PrimePermutID][SubPermutID][k] == 3 )
                      {
                        Answer[AnswerSize ++ ] = -(2 * N - j);
                        Answer[AnswerSize ++ ] = 2 * N - i;
                        Answer[AnswerSize ++ ] = -(2 * N - j);
                        Answer[AnswerSize ++ ] = 2 * N - i;
                      };
                }
            };
    printf("%d\n",AnswerSize);
    for (int i = 0 ; i < AnswerSize ; i ++ )
        if ( Answer[i] > 0 )
        printf("+%d\n",Answer[i]);
    else
            printf("%d\n",Answer[i]);
        }
    return 0;
}
