/* GCC */
#include <stdio.h>
#include <algorithm>
using namespace std;

const int maxN = 256000;
const int INF = 1000000000;
int N;
int X[maxN], Y[maxN], pR[maxN], pL[maxN];
int sTop, s[maxN];
long long Ans;

inline void pop(){ sTop--;}
inline int top(){ return s[sTop];}
inline void push(int a){sTop++; s[sTop] = a;}
long long dist(int x, int y){
     if (x == -1 || y == -1) return 0;
     else return (long long) abs(X[x]-X[y])+abs(Y[x]-Y[y]);
}

int main(){
    freopen("nests.in", "r", stdin);
    freopen("nests.out", "w", stdout);
    scanf("%d", &N);
    Y[0] = INF;
    for(int i = 0; i < N+1; i++) pR[i] = pL[i] = -1;
    for(int i = 1; i < N+1; i++){
      scanf("%d %d", &X[i], &Y[i]);
      while(Y[top()] < Y[i]){
        pR[i] = top();
        pop();
      }
      pL[top()] = i;
      push(i);
    }
    
    for(int i = 1; i < N+1; i++){
            Ans += dist(i, pR[i]);
            Ans += dist(i, pL[i]);
    }
    if (Ans > INF){ printf("%d%09d\n", (int) Ans/INF, (int)Ans%INF); return 0;}
    printf("%d\n", (int) Ans%INF);
}
